<script lang="ts" setup>
import { PhMinus, PhPlus } from '@phosphor-icons/vue';
import { ref, watch } from '#imports';

const props = defineProps({
  modelValue: {
    type: Number,
    default: 1,
  },
  index: {
    type: Number,
  },
});

const emit = defineEmits(['update:modelValue']);
const quantity = ref(props.modelValue);

const increaseQuantity = () => {
  quantity.value++;
  emit('update:modelValue', quantity.value);
};

const decreaseQuantity = () => {
  if (quantity.value > 1) {
    quantity.value--;
    emit('update:modelValue', quantity.value);
  }
};

watch(
  () => props.modelValue,
  (newValue) => {
    quantity.value = newValue;
  },
);
</script>

<template>
  <div :id="'quantity-selector-' + index" class="quantity-selector mt-2">
    <Button
      class="selector p-3"
      :class="{ disabled: quantity < 2 }"
      aria-label="Decrease quantity"
      @click.prevent="decreaseQuantity"
    >
      <PhMinus :size="16" />
    </Button>

    <p
      class="text-md w-8 text-center self-center select-none"
      aria-live="polite"
      aria-atomic="true"
    >
      {{ quantity }}
    </p>

    <Button
      class="selector p-3"
      @click.prevent="increaseQuantity"
      aria-label="Increase quantity"
    >
      <PhPlus :size="16" />
    </Button>
  </div>
</template>
